// get_line -- read a line into malloc()ed memory,
// realloc()ing more if necessary.
// plug compatable with gnu getline().

static const char rcsid[] =
"$Id: get_line.c,v 1.1 2002/08/13 04:45:50 schwartz Exp $";

#include <stdlib.h>
#include <stdio.h>
#include "get_line.h"

static int need(unsigned long n, char **linep, unsigned long *np);

unsigned long get_line(char **linep, unsigned long *np, FILE *fp)
{
    int ch;
    unsigned long n = 0;
 
    while ((ch = fgetc(fp)) != -1) {
	if (need(n+1,linep,np)) return -1;
	(*linep)[n++] = ch;
	if (ch == '\n') break;
    }
    if (need(n+1,linep,np)) return -1;
    (*linep)[n] = 0;
    if (n == 0 && ch == -1) return -1;
    return n;
}

static int need(unsigned long n, char **linep, unsigned long *np)
{
    char *p;
    if (*np <= n) {
	*np += (*np >> 5) + 16;
	if ((p = realloc(*linep, *np)) == 0)
	    return -1;
	*linep = p;
    }
    return 0;
}

#ifdef TEST
int main()
{
    char *line = 0;
    unsigned long nb = 0;
    unsigned long len = 0;

    while ((len = get_line(&line,&nb,stdin)) != -1) {
	printf("%ld/%ld:{%s}\n", len, nb, line);
    }
    if (ferror(stdin))
	perror("get_line");
    exit(0);
}
#endif
